require "simple/cli"
require "table_print"

Dir.glob("#{File.dirname(__FILE__)}/cli/**/*.rb").sort.each do |path|
  load(path)
end

load "config/postjob_cli.rb" if File.exist?("config/postjob_cli.rb")

module Postjob::CLI
  include ::Simple::CLI

  def run!(command, *args)
    Postjob.logger = logger
    load_environment!

    super
  end

  private

  def load_environment(path)
    return unless File.exist?(path)

    logger.debug "#{path}: loading Postjob configuration"
    load path
  end

  def load_environment!
    load_environment("config/environment.rb")
    load_environment("config/postjob.rb")
  end
end
