# rubocop:disable Lint/HandleExceptions

module Postjob::CLI
  # Lists cron jobs in the system
  def cron(limit: "30", queue: nil)
    limit = Integer(limit)
    queue = queue.split(",") if queue

    connect_to_database!

    query = ps_query(limit: limit, queue: queue, tags: nil)
    query = query.where("cron_interval IS NOT NULL")
    # query = query
    print_results query: query
  end

  def cron_top(limit: "30", queue: nil)
    loop do
      system "clear"
      cron limit: limit, queue: queue
      sleep 1
    end
  rescue Interrupt
  end

  # Enqueues a cron workflow
  def cron_enqueue(workflow, *args, interval:, queue: nil, tags: nil)
    interval = Integer(interval)

    connect_to_database!

    Postjob.enqueue! workflow, *args, queue: queue, tags: parse_tags(tags), cron_interval: interval
  end

  # Disable an existing cron job
  def cron_disable(workflow, *args)
    connect_to_database!
    Postjob::Queue.disable_cron_jobs(workflow, args)
  end
end
