module Postjob::CLI
  # Enqueues a workflow
  #
  # Adds a workflow to the job table, with name <workflow> and the given
  # arguments.
  #
  # Note that the workflow will receive the arguments as strings and must be
  # prepared to handle these.
  def enqueue(workflow, *args, queue: nil, tags: nil, count: "1")
    count = Integer(count)

    connect_to_database!

    count.times do
      Postjob.enqueue! workflow, *args, queue: queue, tags: parse_tags(tags)
    end
  end
end
