

module Postjob::CLI
  private

  def parse_ids(*ids)
    ids.map do |s|
      s = s.gsub(/.*\./, "")
      Integer(s)
    end.uniq
  end

  def print_results(query:, on_empty: nil, title: nil)
    if title
      puts "\n=== #{title} =======================================\n\n"
    end

    records = Simple::SQL.print(query)

    if records.total_count && records.total_count > records.length
      logger.warn "Output limited up to limit #{records.length}. Use the --limit=<NN> command line option for a different limit."
    end

    if records.empty? && on_empty
      logger.warn(on_empty)
    end
  end
end
