module Postjob::CLI
  def registry
    puts "=== Queues =========================================================="
    puts Postjob::Registry.queues.join(", ")
    puts "=== Workflows ======================================================="
    require "table_print"

    workflows_with_versions = Postjob::Registry.workflows.keys.reject { |k| k[1] == "" }
    workflows_with_versions = workflows_with_versions.sort_by { |name, _version| name }

    data = workflows_with_versions.map do |name, version|
      spec = Postjob::Registry.lookup! name: name, version: version
      {
        name: name,
        options: spec.options.inspect
      }
    end

    tp data
  end
end
