module Postjob
  class Error < RuntimeError
    attr_reader :message

    def initialize(err)
      case err
      when ::Postjob::Job then @message = job_error_msg(err)
      when nil, false then @message = self.class.name
      else @message = err.to_s
      end
    end

    def to_s
      message
    end

    private

    def job_error_msg(job)
      error_msg = "Failing child job"
      error_msg += " [#{job.result}]" if job.result
      error_msg
    end
  end

  class Error::Nonrecoverable < Error
  end

  class Error::Encoding < Error::Nonrecoverable
  end
end
