pg_types = <<~SQL
  SELECT pg_namespace.nspname AS schema, pg_type.typname AS name
  FROM pg_type
  LEFT JOIN pg_namespace on pg_namespace.oid=pg_type.typnamespace
SQL

unless SQL.ask("SELECT 1 FROM (#{pg_types}) sq WHERE (schema,name) = ($1, $2)", SCHEMA_NAME, "statuses")
  SQL.exec <<~SQL
    CREATE TYPE #{SCHEMA_NAME}.statuses AS ENUM (
      'ready',    -- process can run
      'sleep',    -- process has external dependencies to wait for.
      'failed',   -- process failed, with nonrecoverable error
      'err',      -- process errored (with recoverable error)
      'timeout',  -- process timed out
      'ok'        -- process succeeded
    );
  SQL
end
