DROP FUNCTION IF EXISTS {SCHEMA_NAME}._set_job_processing(job_id BIGINT);  -- removed in 0.5.0
CREATE OR REPLACE FUNCTION {SCHEMA_NAME}._set_job_processing(worker_session_id UUID, job_id BIGINT) RETURNS VOID AS $$
DECLARE
  v_pid int;
  v_host_id uuid;
BEGIN
  v_pid := pg_backend_pid();
  SELECT host_id INTO v_host_id FROM {SCHEMA_NAME}.worker_sessions WHERE id=worker_session_id;

  UPDATE {SCHEMA_NAME}.postjobs
  SET
    last_worker_session_id=worker_session_id,
    status='processing',
    error=NULL,
    error_message=NULL,
    error_backtrace=NULL,
    next_run_at=NULL,
    sticky_host_id=(CASE WHEN is_sticky THEN v_host_id ELSE NULL END)
  WHERE id=job_id;
END;
$$ LANGUAGE plpgsql;

DROP FUNCTION IF EXISTS {SCHEMA_NAME}._reset_job_processing(job_id BIGINT);  -- removed in 0.5.0
CREATE OR REPLACE FUNCTION {SCHEMA_NAME}._reset_job_processing(worker_session_id UUID, job_id BIGINT) RETURNS VOID AS $$
BEGIN
  UPDATE {SCHEMA_NAME}.postjobs
  SET
    last_worker_session_id=worker_session_id
  WHERE id=job_id;
END;
$$ LANGUAGE plpgsql;
