module Postjob::Queue
  def settings?
    tables = SQL::Reflection.tables(schema: "postjob")
    tables.include?("postjob.settings")
  end

  # returns the version of the Postjob queue.
  def version
    return "0.3.*" unless settings?

    sql = <<~SQL
      SELECT 1 from pg_proc
      left join pg_namespace on pg_proc.pronamespace=pg_namespace.oid
      where pg_namespace.nspname='postjob' AND pg_proc.proname='settings_get'
    SQL

    if Simple::SQL.ask(sql)
      version = Simple::SQL.ask "SELECT postjob.settings_get('schema_version')"
      version ||= Simple::SQL.ask "SELECT postjob.settings_get('version')"
    else
      version = Simple::SQL.ask("SELECT value FROM postjob.settings WHERE name=$1", "version")
    end

    version || "unknown"
  end
end
